\section{Astrometric\label{wcs}}

Astrometric calibration consists of determining the celestial coordinates of
every pixel in the exposure.  This is done using a non-linear function fit
mapping the measured pixel positions of sources in an image to the celestial
coordinates of those same sources obtained from  a reference catalog.  This
mapping is generally referred to as world coordinate systems (WCS).  Though
separate WCS functions must be determine for each image in the mosaic
instrument we will generally refer to the collection of functions as the WCS
for the exposure.  The most challenging algorithm in the astrometric
calibration is matching detected sources in the exposure to reference
sources in a catalog.

Initially the raw data has a WCS set by the data
acquisition system.  The pipeline overrides this if there is another
applicable WCS in the calibration library.  In either case the WCS is only
approximate because of uncertainties in the telescope pointing and
offsets to the instrument field, small mounting errors,
and atmospheric distortion effects.

The astrometric calibration begins by creating two catalogs.  The
first is a catalog of sources extracted from a reference catalog for
the field covered by the exposure.  Because of the telescope pointing 
uncertainties a field larger that that of the exposure is extracted.
In the Mosaic pipeline a circular field from the USNO-B catalog is
used.  The catalog contains the right ascension and declination of the
sources along with g, r, and i magnitudes computed from the J, F, and
N photographic material defining the USNO-B catalog.

The second catalog is a detection catalog containing the pixel
centroids and digital instrumental magnitudes of sources in the
exposure.  The matching of sources from the two catalogs uses a
coarse offset determination from the bright sources followed by a fine
centroiding of all sources.  The coarse offset determination 

[Flags]
[Algorithm info here]

A raster of potential pixel offsets from the nomimal position of a reference
source is used to accumulate "votes" for the offset.  The raster size
is set by a parameter defining the maximum postion error.  The raster
bin size is one pixel in the target coordinate system.  The votes are
cast by computing the pixel coordinates for each reference celestial
coordinate in the target image.  All target catalog sources within the
raster then cast a vote for the offset.

Because this is an N*M operations and a high density of sources takes
the power out of the method, the magnitudes of the reference and image
sources are used to limit the set of sources used.  

There are uncertainities in the source position from the WCS solution,
proper motion, and seeing.  The vote is distributed over
an region by convolving the position of the catalog by a Gaussian.  In
effect, the delta function of the catalog position is turned into a
Gaussian profile.  The width of the profile is a parameter.  For
MOSAIC data the full-width-half-max of the convolution is 1 arc
second.  In implementation the convolution is applied to the vote
array after all the delta function votes are cast.

This algorithm was initially developed to work from image data rather
than catalog data.  The convolution of the catalog source positions is
basically equivalent to simulating an stellar image for this
algorithm.

After all the votes are cast and the vote array is convolved it is
searched for maxima.  If there is no point which is at least 20 sigma
above the average the algorithm reports a failure.  A threshold is
then set at a point half way between the maximum value and the average
value.  Then a weighted centroid is computed using the value above the
threshold.  The centroid relative to the center of the vote array
gives a coarse offset.

[Wriggle for rotations]

Once the coarse offset is determined a simple closest radius match between the
source catalog and the reference catalog is performed.  The nearest
source to a reference catalog that is within 2 arc seconds forms a
match between a source and reference.  These matches produce a
"matched catalog".  

The matched catalog is used to produce the photometric and astrometric
calibrations.

The advantage of this algorithm is that is fast, it works in the
presence of significant distortions.

This algorithm allows parallelization by generating the source
catalogs in parallel, requires only the catalogs to be brought
together, and the vote accumulation can be done over all the pieces of
a mosaic.

\subsection{Photometric Calibration}

The photometric calibration produced by the Mosaic pipeline is intended as a
rough guide to the depth of the exposure.  It is based solely on the single
exposure so there are no color terms.  It also depends only
on the sources in the exposure rather than reference to a standard star
exposure.  In the future the pipeline may identify and use standard star
observations within the dataset.

Since the primary reference catalog is USNO-B and there is a wide variety of
principle investigator programs using the full complement of Mosaic Camera
filters the photometric system is not a close match.  What the calibration
does is to determine a photometric scale or zero point magnitude that
matches, on average, the instrumental fluxes to the reference fluxes of the
matched catalog sources in a reference flux photometric system.

The USNO-B catalog provides photograhic magnitudes.  For much of the
sky these are based on the J, F, and N emulsions.  Where this is not
available the O and E emulsions are available.  Rather than provide
the zero points in one of these bands the published calibrations to
the SDSS g, r, and i systems are used.

The calibration library provides for a transformation from (g, r, i) to some
other system based on the Mosaic filter.  Currently only identity transforms
are used with the particular SDSS system set in the library being defined by
wavelength proximity.  For example, blue broad or naorrow band filters use
g, yellow and red to r, and far red to i.  In the event that there is
no N reference magnitude for far red filters the calibration is made
to r where a transformation from O and E is defined.

A selection is made from the matched catalog to eliminate sources with
questionable or low signal-to-noise instruental magnitudes.  First all
sources which the catalog identifies as being impacted by saturation,
blead trails, or bad pixels (see \S\ref{sec:sat}) are excluded.
Remembering that the instruental magnitudes in catalog are calibrated
to the expected zero point for the filter using the calibration
library, large magnitude differences (greater than 20) are rejected.
Next the brightest 10\% and faintest 20\% of sources (ref \& cat mags?)
are excluded.  Finally, the remaining matched sources are averaged to
yeild the approximate photometric zero point.

Both the mean and sigma are computed and recorded for data quality
reference.  Sources in the output matched catalog which are more than
3 sigma from the mean are flagged.

The zero point and sigma are computed both independently for each CCD
and over all CCDs.  Note that this is not the average of each of the
calibrations for each CCD but the values using all sources in all
CCDs.  This simply means that the weighting of the CCDs for the final
exposure zero point is by the number of matched and accepted sources.

Because the reference pbotometry is typically not in the same
photometric system as the 

\subsection{Astrometric Calibration}

in the image using the initial WCS as a guide and produces an
accurate WCS for the data.



The astrometric calibration is one area that cannot be totally parallelized.
This is because, at least for our data, using sources from all the images
produces a more robust match to the reference catalog.  The initial world
coordinate system (WCS) includes the stable physical relationship between
the CCDs.  The uncertainty in the astrometric calibration is then a zero
point offset, a small rotation from remounting the camera between
maintenance periods, and atmospheric distortions.  The parallelization of
the astrometric calibration consists of generating source catalogs for each
CCD in parallel.  This is typically distributed across nodes with the bulk
image data.  The catalogs are then combined and matched on one pipeline node
against a reference catalog selected using the assumed telescope pointing.
Because only the catalogs are used to determine the astrometric calibrations
the data transfers are small.  The penalty is primarily the need to
synchronize the processing for an exposure at this point.  This is offset by
allowing other parallel calibrations steps to proceed at their own pace
after the catalogs are generated and sent to the global astrometric
calibration node.  Once the solutions for each CCD are determined they are
sent back to the nodes where the calibrations are being done.

The matching algorithm is too complex to describe here.  Basically since the
camera orientation is fixed and the scales are known and stable a
correlation offset in x and y is used as opposed to a more sophisticated
triangle matching algorithm required for arbitrary relative orientations.

The detection catalog and catalog matching are performed using tasks
from the ACE (Astronomical Cataloging Environment) package.  The WCS
function fitting and evaluations are from the core IRAF system tasks.

